

% TMP01 SENSOR - OCTAL THERMOCOUPLE MONITOR 1.1.0


% Class TMP01_Sensor
classdef TMP01_Sensor < handle

   % Public static Constants
   properties (Constant)

      % Types
      TYPE_NONE = 0;
      TYPE_CUSTOM = 1;
      TYPE_B = 2;
      TYPE_C = 3;
      TYPE_D = 4;
      TYPE_E = 5;
      TYPE_G = 6;
      TYPE_J = 7;
      TYPE_K = 8;
      TYPE_M = 9;
      TYPE_N = 10;
      TYPE_P = 11;
      TYPE_R = 12;
      TYPE_S = 13;
      TYPE_T = 14;

   end


   % Public Member Methods
   methods

      % Constructor
      function this = TMP01_Sensor(type)

         % Check Parameters
         if ~nargin

            % Initialize
            this.type(this.TYPE_NONE);

         else

            % Initialize
            this.type(type);

         end

      end


      % Get / Set Type
      function type_ = type(this, type)

         % Check Parameters
         if nargin == 1

            % Return Type
            type_ = this.type_;

         else

            % Check Type
            if (type ~= this.TYPE_NONE) && (type ~= this.TYPE_CUSTOM) && (type ~= this.TYPE_B) && ...
               (type ~= this.TYPE_C) && (type ~= this.TYPE_D) && (type ~= this.TYPE_E) && (type ~= this.TYPE_G) && ...
               (type ~= this.TYPE_J) && (type ~= this.TYPE_K) && (type ~= this.TYPE_M) && (type ~= this.TYPE_N) && ...
               (type ~= this.TYPE_P) && (type ~= this.TYPE_R) && (type ~= this.TYPE_S) && (type ~= this.TYPE_T)

               % Error Handler
               Device.error_(Device.ERROR_PARAMETER_);

            end

            % Set Type
            this.type_ = type;

         end

      end

   end


   % Private Properties
   properties (Access = private)

      % Variables
      type_;

   end

end
